/*所有的监听事件*/
function onCommonListener() {
    mypomelo.on({ route: 'onMsg_gameStart' }, function (data) {
        if (data.errno == 0) {
            var s_c_body = data.data;
            if (typeof vue.scenePlay === "function" && vue.pageType == s_c_body.roomType) {
                vue.scenePlay(s_c_body);
            } else {
                if (s_c_body.roomType == 'hydz' || s_c_body.roomType == 'QS') {
                    vue.openPage('play_chess/create_room');
                } else if (s_c_body.roomType == 'qlcp') {
                    vue.openPage('play_chess/qlcp');
                } else {
                    vue.openPage('play_chess/ai_test');
                }
            }
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onKick' }, function (data) {
        var txBugly = api.require('txBugly');
        if (localStorage.getItem('userinfo')) {
            var userinfo = JSON.parse(localStorage.getItem('userinfo'));
            txBugly.setUserValue({
                key:"uid",
                value:userinfo.uid
            })
        }
        txBugly.reportException({
            name:'onKick',
            reason:'onKick 执行原因：'+JSON.stringify(data)+ " 版本:" + api.appVersion
        });
        console.log("onKick 执行原因")
        mypomelo.disconnect();
        vue.dialogType = dialog_login;
        if (typeof tracker != 'undefined' && tracker) {
            tracker.sendImmediate({
                eventType: 'onKick_message',
                eventData: JSON.stringify(data),
                uid: localStorage.getItem('userinfo') ? JSON.parse(localStorage.getItem('userinfo')).uid : '',
                system:api.systemType == 'ios'?'ios':'android',
                deviceId:api.deviceId
            })
        }
    });
    mypomelo.on({ route: 'onMsg_invitePlay' }, function (data) {
        if (data.errno == 0) {
            if (data.data.result) { //消息格式，uid,nickname,agree(false OR true)
                if (vue.popup_unit) vue.popup_unit.show = false;
                if (!data.data.agree) {
                    popupDisplay('对方拒绝了你的约战请求', false, 1.5);
                }
            } else { //约战请求,收到战书。消息格式，uid,nickname,
                if (vue.getBookInfo) {
                    vue.getBookInfo.uid = data.data.uid;
                    vue.getBookInfo.nickname = data.data.nickname;
                    vue.getBookInfo.headimg = data.data.avatar; //头像也需要展示
                    vue.getBookInfo.time = 5;
                    vue.getBook = true;
                    zhanshu_timer = setInterval(function () {
                        vue.getBookInfo.time--;
                        if (vue.getBookInfo.time <= 0 || !vue.getBook) {
                            vue.getBook = false;
                            clearInterval(zhanshu_timer);
                        }
                    }, 1000);
                }
            }
        } else {
            vue.$toast(data.message);
        }
    });
}
function onAnalyseListener() {
    onCommonListener();
    mypomelo.on({ route: 'onMsg_analyseAnalyseData' }, function (data) {
        if (data.errno == 0) {
            try{
                vue.repeatTimes=0;
                vue.AIAnalyseFlag=false;
                console.log(JSON.stringify(data));
                comm.ParseMsg(data);
            }catch(e){
                reportBugly(10+"name"+e.name+" message"+e.message+" stack"+e.stack);
            }
        } else {
            vue.$toast(data.message);
        }
    });
    mypomelo.on({ route: 'onMsg_bestMoveData' }, function (data) {
        if (data.errno == 0) {
            if (!data.data.move || data.data.move.match("checkmate") || data.data.move.match("stalemate") || data.data.move.match("slatemate") || data.data.move.match("none")) {
                comm.onGameEnd();
            } else {
                if(comm.nodes[data.data.params.currentId]){
                    comm.nodes[data.data.params.currentId].score = data.data.score ? data.data.score:0; 
                    comm.nodes[data.data.params.currentId].depth = data.data.depth ? data.data.depth:0;
                }
                if (data.data.params.currentId == currentId) {
                    comm.nodes[data.data.movesIndex].tipsStep[0] = data.data.move;
                    replayBtnUpdate();
                    setTimeout((function () {
                        if (mode == playmode.AIPLAY){
                            if (movesIndex==data.data.params.currentId){
                                if (Player.checkAIPlay(data.data.move)) {
                                    Player.serverAIPlay(data.data.move);
                                }
                            }
                        }else {
                            Player.serverAIPlay(data.data.move);
                        }
                    }), 200);
                }
            }
        } else {
            vue.$toast(data.message);
        }
    });
}
function onMessageListener() {
    onCommonListener();
    mypomelo.on({ route: 'onMsg_chatMessage' }, function (data) {
        if (data.errno == 0) {
            if (vue.type == 'user' && data.data.uid1 == vue.friendid) {
                vue.chatList.push(data.data);
                vue.autoScroll();
                mySendMessage(mysetting.routes.updateMessageStatus, {
                    messageid: data.data.messageid
                }, function (data) {

                });
            }
        } else {
            vue.$toast(data.message);
        }
    });
}

function onGroupMessageListener() {
    onCommonListener();
    mypomelo.on({ route: 'onMsg_chatGroup' }, function (data) {
        if (data.errno == 0) {
            console.log(JSON.stringify(data));
        } else {
            vue.$toast(data.message);
        }
    });
}
function closeEventListener(url) {
    vue.lastTime_closeEventListener = new Date().getTime()
    vue.last_closeEventListener_reason = new Error(url).stack
    if (typeof tracker != 'undefined' && tracker && vue.uid) {
        tracker.sendImmediate({
            eventType: 'closeEventListener_message',
            eventData: JSON.stringify(url),
            uid: vue.uid,
            deviceId: api.deviceId,
            system: api.systemType == 'ios' ? 'ios' : 'android',
            stack: new Error().stack
        })
    }
    vue.noListener = true;
    mypomelo.off({all: true});
    try{
        api.setGlobalData({
            key: 'global_last_closeEventListener',
            value: {
                url: window.document.URL.toString(),
                lastTime_closeEventListener: vue.lastTime_closeEventListener,
                last_closeEventListener_reason: vue.last_closeEventListener_reason
            }
        });
    }
    catch(e)
    {
        console.log("eeeeeeeeeeeeeeeeeee", e.stack)
    }

    // 当前页面不管reinitEventListener这个事件
    api.removeEventListener({
        name:'reinitEventListener'
    })
    // 由于off会把其他页面的侦听器一起删除，所以要通知其他页面重新侦听
    api.sendEvent({
        name:'reinitEventListener',
        extra: JSON.stringify({
            url: url,
            document: window.document.URL.toString()
        })
    })
}